#ifndef GANGU_BLENDER
#define GANGU_BLENDER

class blender_module
{
public:
	blender_module(){}

	py::dict getBlenderModule()const
	{
		py::handle<> bmod( py::borrowed( PyImport_ImportModule( "Blender" ) ) );
		return py::dict( py::borrowed( PyModule_GetDict( bmod.get() ) ) );
	}

	py::object Scene()const
	{
		return getBlenderModule()["Scene"];
	}
	py::object Object()const
	{
		return getBlenderModule()["Object"];
	}
	py::object NMesh()const
	{
		return getBlenderModule()["NMesh"];
	}
	py::object Material()const
	{
		return getBlenderModule()["Material"];
	}
	py::object Texture()const
	{
		return getBlenderModule()["Texture"];
	}
	py::object Image()const
	{
		return getBlenderModule()["Image"];
	}
	py::object Window()const
	{
		return getBlenderModule()["Window"];
	}

	py::object Mathutils()const
	{
		return getBlenderModule()["Mathutils"];
	}

	py::object Modifier()const
	{
		return getBlenderModule()["Modifier"];
	}
	py::object Mesh()const
	{
		return getBlenderModule()["Mesh"];
	}
	py::object Group()const
	{
		return getBlenderModule()["Group"];
	}

	py::dict GANGu()const
	{
		return py::dict( getBlenderModule()["Registry"].attr("GetKey")("GANGu",1) );
	}
};

const blender_module Blender;

inline void SendProgress( double pr, const char *msg )
{
	Blender.Window().attr("DrawProgressBar")( pr, msg );
}

#endif
