#ifndef GANGU_PROGRESS_PARSER
#define GANGU_PROGRESS_PARSER


namespace boost { namespace spirit {

namespace {

template<bool F>
struct first_distance_holder
{
	static long size;
};

template<bool F> long first_distance_holder<F>::size = 0;

}

inline float solve_progress( long diff )
{
	typedef first_distance_holder<true> h;
	if( h::size == 0 ){
		h::size = diff;
		return 0.0f;
	}
	else{
		return (double)( h::size - diff ) / (double)( h::size );
	}
}

struct progress_parser: parser<progress_parser>
{
	typedef progress_parser self_t;

	progress_parser(){}
	progress_parser( self_t const & ){}

	template<class ScannerT>
	struct result
	{
		typedef typename match_result<ScannerT, double>::type type;
	};

	template<class ScannerT>
	typename parser_result<self_t,ScannerT>::type
	parse(ScannerT const &scan) const
	{
		return scan.create_match(0,
			solve_progress( scan.last - scan.first ) , scan.first, scan.first);
	}

};

const progress_parser progress_p;

}//spirit

}//boost

#endif

